package Mypackage;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.util.Map;



import org.eclipse.emf.common.util.BasicEList;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.TreeIterator;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;

import org.eclipse.emf.ecore.impl.DynamicEObjectImpl;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.URIConverter;
import org.eclipse.emf.ecore.resource.impl.ExtensibleURIConverterImpl;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;

import org.eclipse.emf.ecore.util.ECrossReferenceEList;
import org.eclipse.emf.ecore.util.EcoreUtil;







import org.eclipse.ocl.pivot.uml.UMLStandaloneSetup;

import org.eclipse.ocl.pivot.utilities.OCL;
import org.eclipse.ocl.pivot.utilities.OCLHelper;
import org.eclipse.ocl.pivot.utilities.ParserException;

import org.eclipse.uml2.uml.Model;
import org.eclipse.uml2.uml.NamedElement;

import org.eclipse.uml2.uml.Profile;
import org.eclipse.uml2.uml.Stereotype;
import org.eclipse.uml2.uml.UMLPackage;
import org.eclipse.uml2.uml.resources.util.UMLResourcesUtil;
import org.eclipse.uml2.uml.Constraint;





public class Ocltest {

	public static void main(String[] args) {
		final String input ="NewModels/out2.uml";
		pivotValidation(input);
		
	}
	

	private static void pivotValidation(String input)
	{
		// TODO Auto-generated method stub
		UMLStandaloneSetup.init();
		org.eclipse.ocl.xtext.essentialocl.EssentialOCLStandaloneSetup.doSetup();

    
        System.out.println("Initialization");
        ResourceSet rs = new ResourceSetImpl();
      
        
        
        File file = new File(input);
		
		
		
			
		UMLResourcesUtil.init(rs);
		
		Resource resource = rs.getResource(
				URI.createFileURI(file.getAbsolutePath().toString()), true);
		
		Model uml = (Model) resource.getContents().get(0);
		
	

        
		
        OCL ocl = OCL.newInstance(rs);

     
        System.out.println("Root: " + uml);
        
		

        EList<Constraint> constraints = new BasicEList<Constraint>(uml.getOwnedRules());
        

		// Get all OCL rules from the profiles applied to the model
		getOCLRulesFromAppliedProfiles(uml, constraints);
				
		for (Constraint constraint : constraints) {
			
				
				org.eclipse.uml2.uml.Namespace context= constraint.getContext();
			

				OCLHelper oclHelper = null;

						
		
					final EList<org.eclipse.uml2.uml.Element> oeList = uml.allOwnedElements();

					for (org.eclipse.uml2.uml.Element oe : oeList) {
						if (oe.isStereotypeApplied((Stereotype) context)) {
							System.out.println("\n Owned element, an stereotype is applied: "+oe);
							
							org.eclipse.ocl.pivot.Constraint asConstraint = null;
							org.eclipse.ocl.pivot.ExpressionInOCL asExpression = null;
							
							
							try {
								asConstraint = ocl.getMetamodelManager().getASOf(org.eclipse.ocl.pivot.Constraint.class, constraint);
								
								System.out.println("Pivot constraint: "+asConstraint);
								System.out.println("constraint: "+asConstraint);
								try {
									asExpression = ocl.getSpecification(asConstraint);
									System.out.println("Pivot constraint Expression:" + asExpression);
								} catch (ParserException e) {
									// TODO Auto-generated catch block
									e.printStackTrace();
								}
							} catch (ParserException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
							
							System.out.println("Target class: " + oe);
							EObject eo = findTargetObject(oe, resource);
						System.out.println("Validation result: "+ocl.evaluate(eo, asExpression));
							
							
							
							try {
								oclHelper= ocl.createOCLHelper(eo);
							} catch (ParserException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							}
							
							
							

					}
					}

		}
        
		ocl.dispose();		
	}
	
	private static EObject findTargetObject(Object o, Resource resource)
	{
		EObject target = null;

		for (EObject eo : resource.getContents()) {
			if(eo instanceof DynamicEObjectImpl)
			{
				DynamicEObjectImpl dei = (DynamicEObjectImpl) eo;	

				ECrossReferenceEList<EObject> i = (ECrossReferenceEList<EObject>) dei.eCrossReferences();

				if( i.contains(o))
				{
					System.out.println("Target found: "+eo);
					return eo;
				}


			}

		}
		
		return target;
	}
	
	
    private static EList<Constraint> getOCLRulesFromAppliedProfiles(Model uml, EList<Constraint> constraints) {
		// TODO Auto-generated method stub
		for (Profile profile : uml.getAllAppliedProfiles()) {

			final TreeIterator<EObject> profileIterator = profile.eAllContents();
			while (profileIterator.hasNext()) {
				EObject tempObject = profileIterator.next();

				if (tempObject instanceof NamedElement) {
					NamedElement ne = (NamedElement) tempObject;

					if (ne.getNamespace() != null) {
						final EList<Constraint> temp = ne.getNamespace().getOwnedRules();

						if (!constraints.containsAll(temp)) {
							constraints.addAll(temp);

						}
					}
				}
			}
		}
		return constraints;		
	}

}



